//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  ja-jp ̕ en-us ɒu URL uEUŕ\
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2019N0724 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1)   + Delphi XE5(UP2) Pro VCL-32
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, NkClipDetector, Vcl.StdCtrls,
  Vcl.ComCtrls, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    RichEdit1: TRichEdit;
    Button2: TButton;
    NkClipDetector1: TNkClipDetector;
    Button1: TButton;
    procedure NkClipDetector1ClipChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    FBrowserWnd : HWND;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Clipbrd,
  System.StrUtils;

{$R *.dfm}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Caption := 'MSDN URL u';

  RichEdit1.PlainText  := True;
  RichEdit1.ScrollBars := ssBoth;
  RichEdit1.Font.Size  := 12;

  Self.FormStyle := fsStayOnTop;

  RichEdit1.Lines.Clear;

  FBrowserWnd := FindWindow('Chrome_WidgetWin_1', nil);
  if FBrowserWnd = 0 then begin
    FBrowserWnd := FindWindow('MozillaWindowClass', nil);
  end;
  if FBrowserWnd = 0 then begin
    // IE 11 ̃nh͈ȉŎ擾ł邪C{vŐ@\͎gps
    // FBrowserWnd := FindWindow('IEFrame', nil);
  end;

  Button1.Enabled := FBrowserWnd <> 0;
  Button2.Enabled := False;
end;

//=============================================================================
//  uEU URL ͗̃AhX擾
//  uEU URL ͗NbNĂs
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
begin
  if FBrowserWnd = 0 then Exit;
  Self.FormStyle := fsNormal;

  SetForegroundWindow(FBrowserWnd);

  keybd_event(VK_CONTROL, 0, 0, 0);
  keybd_event(Ord('A'),   0, 0, 0);
  keybd_event(Ord('A'),   0, KEYEVENTF_KEYUP, 0);
  keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
  Application.ProcessMessages;

  keybd_event(VK_CONTROL, 0, 0, 0);
  keybd_event(Ord('C'),   0, 0, 0);
  keybd_event(Ord('C'),   0, KEYEVENTF_KEYUP, 0);
  keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);
  Application.ProcessMessages;

  Sleep(300);
  SetForegroundWindow(Handle);
  Self.FormStyle := fsStayOnTop;
end;

//=============================================================================
//  ja-jp ̕ en-us ɒu URL uEUŕ\
//  s,ϊ URL ̒lNbv{[hɃZbgĂ
//  RichEdit1 ɕ\Ă̂ϊ URL ̒l
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
begin
  if FBrowserWnd = 0 then Exit;
  if Trim(RichEdit1.Text) = '' then Exit;
  Self.FormStyle := fsNormal;

  Clipboard.AsText := RichEdit1.Text;

  SetForegroundWindow(FBrowserWnd);

  keybd_event(VK_CONTROL, 0, 0, 0);
  keybd_event(Ord('V'),   0, 0, 0);
  keybd_event(Ord('V'),   0, KEYEVENTF_KEYUP, 0);
  keybd_event(VK_CONTROL, 0, KEYEVENTF_KEYUP, 0);

  keybd_event(VK_RETURN, 0, 0, 0);
  keybd_event(VK_RETURN, 0, KEYEVENTF_KEYUP, 0);

  Sleep(300);
  SetForegroundWindow(Handle);
  Self.FormStyle := fsStayOnTop;
  Button2.Enabled := False;
end;

//=============================================================================
//  TNkClipDetectorOnClipChangeCxg
//  Nbv{[h̊ĎCxg
//  TNkClipDetector ͒j̃R|[lg
//=============================================================================
procedure TForm1.NkClipDetector1ClipChange(Sender: TObject);
var
  LURLText  : string;
  LLastChar : string;
begin
  RichEdit1.Lines.Clear;
  if Clipboard.HasFormat(CF_TEXT) then begin
    LURLText := Clipboard.AsText;
    if ContainsText(LURLText, 'microsoft.com/ja-jp/') then begin
      LURLText := ReplaceText(LURLText, 'ja-jp', 'en-us');
      LLastChar := LURLText[Length(LURLText)];
      if LLastChar = 'a' then begin
        LURLText[Length(LURLText)] := 'w';
      end;
      RichEdit1.Text :=  LURLText;
      Button2.Enabled := True;
    end else
    if ContainsText(LURLText, 'microsoft.com/en-us/') then begin
      LLastChar := LURLText[Length(LURLText)];
      if LLastChar = 'a' then begin
        LURLText[Length(LURLText)] := 'w';
      end;
      RichEdit1.Text :=  LURLText;
      Button2.Enabled := True;
    end;
  end;
end;

end.
